SystemOrganization addCategory: #ConfigurationOfFixedDecimal!

Object subclass: #ConfigurationOfFixedDecimal
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFixedDecimal'!

!ConfigurationOfFixedDecimal class methodsFor: 'development support' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFixedDecimal class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFixedDecimal class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFixedDecimal class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFixedDecimal class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFixedDecimal class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFixedDecimal class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFixedDecimal class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFixedDecimal class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
project

	^self new project! !

!ConfigurationOfFixedDecimal class methodsFor: 'development support' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFixedDecimal methodsFor: 'baselines' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemtalksystems.com/ss/MetaRepoForPharo20'.
		spec 
			package: 'FixedDecimal';
			package: 'FixedDecimal Tests'.
		spec group: 'default' with: #('FixedDecimal' 'FixedDecimal Tests' ). ].
! !

!ConfigurationOfFixedDecimal methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfFixedDecimal methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 8/12/2013 08:25'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfFixedDecimal methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2013 08:22'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfFixedDecimal methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 8/12/2013 08:25'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfFixedDecimal methodsFor: 'versions' stamp: 'HernanMoralesDurand 8/12/2013 08:25'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'A FixedDecimal is similar to a ScaledDecimal, but different in certain select ways. It''s primary purpose was to be able to represent precise decimals for such things as representing money - where ScaledDecimals leave something to be desired.

For instance, with ScaledDecimals, you get:

(33.333s withScale:2) + (33.333s withScale:2) = 66.67s 

but with FixedDecimals, you would get:

(33.333 asFixedDecimal: 2) + (33.333 asFixedDecimal: 2) = 66.66. 

So, FixedDecimals round the numbers to the exact scale you specify - converting a float (or fraction) to a FixedDecimal and back will not necessarily return the starting number, unlike ScaledDecimals.

Forked from http://www.squeaksource.com/FixedDecimal.html Credits to Chris Cunningham
A FixedDecimal is similar to a ScaledDecimal, but different in certain select ways. It''s primary purpose was to be able to represent precise decimals for such things as representing money - where ScaledDecimals leave something to be desired.

For instance, with ScaledDecimals, you get:

(33.333s withScale:2) + (33.333s withScale:2) = 66.67s 

but with FixedDecimals, you would get:

(33.333 asFixedDecimal: 2) + (33.333 asFixedDecimal: 2) = 66.66. 

So, FixedDecimals round the numbers to the exact scale you specify - converting a float (or fraction) to a FixedDecimal and back will not necessarily return the starting number, unlike ScaledDecimals.

Forked from http://www.squeaksource.com/FixedDecimal.html Credits to Chris Cunningham'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/12/2013 08:24'.
		spec 
			package: 'FixedDecimal' with: 'FixedDecimal-cbc.20';
			package: 'FixedDecimal Tests' with: 'FixedDecimal Tests-TorstenBergmann.3'. ].
! !
